--------------------------------------------------------------------------------
-- Copyright (c) 1995-2003 Xilinx, Inc.
-- All Right Reserved.
--------------------------------------------------------------------------------
--   ____  ____ 
--  /   /\/   / 
-- /___/  \  /    Vendor: Xilinx 
-- \   \   \/     Version : 9.1.03i
--  \   \         Application : ISE
--  /   /         Filename : ADC_box_01.vhw
-- /___/   /\     Timestamp : Mon Jul 16 10:47:49 2007
-- \   \  /  \ 
--  \___\/\___\ 
--
--Command: 
--Design Name: ADC_box_01_tb_0
--Device: Xilinx
--

library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;
USE IEEE.STD_LOGIC_TEXTIO.ALL;
USE STD.TEXTIO.ALL;

ENTITY ADC_box_01_tb_0 IS
END ADC_box_01_tb_0;

ARCHITECTURE testbench_arch OF ADC_box_01_tb_0 IS
    FILE RESULTS: TEXT OPEN WRITE_MODE IS "results.txt";

    COMPONENT ADC_box
        PORT (
            Clk : In std_logic;
            iRst : In std_logic;
            Go : In std_logic;
            Wr : In std_logic;
            A_in : In std_logic_vector (2 DownTo 0);
            Error : Out std_logic;
            A_out : Out std_logic_vector (2 DownTo 0);
            D : Out std_logic_vector (11 DownTo 0)
        );
    END COMPONENT;

    SIGNAL Clk : std_logic := '0';
    SIGNAL iRst : std_logic := '0';
    SIGNAL Go : std_logic := '0';
    SIGNAL Wr : std_logic := '0';
    SIGNAL A_in : std_logic_vector (2 DownTo 0) := "000";
    SIGNAL Error : std_logic := '0';
    SIGNAL A_out : std_logic_vector (2 DownTo 0) := "000";
    SIGNAL D : std_logic_vector (11 DownTo 0) := "000000000000";

    constant PERIOD : time := 200 ns;
    constant DUTY_CYCLE : real := 0.5;
    constant OFFSET : time := 100 ns;

    BEGIN
        UUT : ADC_box
        PORT MAP (
            Clk => Clk,
            iRst => iRst,
            Go => Go,
            Wr => Wr,
            A_in => A_in,
            Error => Error,
            A_out => A_out,
            D => D
        );

        PROCESS    -- clock process for Clk
        BEGIN
            WAIT for OFFSET;
            CLOCK_LOOP : LOOP
                Clk <= '0';
                WAIT FOR (PERIOD - (PERIOD * DUTY_CYCLE));
                Clk <= '1';
                WAIT FOR (PERIOD * DUTY_CYCLE);
            END LOOP CLOCK_LOOP;
        END PROCESS;

        PROCESS
            BEGIN
                -- -------------  Current Time:  100ns
                WAIT FOR 100 ns;
                iRst <= '1';
                -- -------------------------------------
                -- -------------  Current Time:  385ns
                WAIT FOR 285 ns;
                iRst <= '0';
                -- -------------------------------------
                -- -------------  Current Time:  585ns
                WAIT FOR 200 ns;
                iRst <= '1';
                -- -------------------------------------
                -- -------------  Current Time:  985ns
                WAIT FOR 400 ns;
                Go <= '1';
                Wr <= '1';
                A_in <= "001";
                -- -------------------------------------
                -- -------------  Current Time:  1185ns
                WAIT FOR 200 ns;
                Go <= '0';
                Wr <= '0';
                A_in <= "000";
                -- -------------------------------------
                -- -------------  Current Time:  1985ns
                WAIT FOR 800 ns;
                Go <= '1';
                Wr <= '1';
                A_in <= "010";
                -- -------------------------------------
                -- -------------  Current Time:  2185ns
                WAIT FOR 200 ns;
                Go <= '0';
                Wr <= '0';
                A_in <= "000";
                -- -------------------------------------
                -- -------------  Current Time:  4585ns
                WAIT FOR 2400 ns;
                Go <= '1';
                Wr <= '1';
                A_in <= "010";
                -- -------------------------------------
                -- -------------  Current Time:  4785ns
                WAIT FOR 200 ns;
                Go <= '0';
                Wr <= '0';
                A_in <= "000";
                -- -------------------------------------
                -- -------------  Current Time:  8185ns
                WAIT FOR 3400 ns;
                Go <= '1';
                Wr <= '1';
                A_in <= "011";
                -- -------------------------------------
                -- -------------  Current Time:  8385ns
                WAIT FOR 200 ns;
                Go <= '0';
                Wr <= '0';
                A_in <= "000";
                -- -------------------------------------
                -- -------------  Current Time:  11785ns
                WAIT FOR 3400 ns;
                Go <= '1';
                A_in <= "100";
                -- -------------------------------------
                -- -------------  Current Time:  11985ns
                WAIT FOR 200 ns;
                Go <= '0';
                A_in <= "000";
                -- -------------------------------------
                -- -------------  Current Time:  15385ns
                WAIT FOR 3400 ns;
                Go <= '1';
                Wr <= '1';
                A_in <= "101";
                -- -------------------------------------
                -- -------------  Current Time:  15585ns
                WAIT FOR 200 ns;
                Go <= '0';
                Wr <= '0';
                A_in <= "000";
                -- -------------------------------------
                -- -------------  Current Time:  19185ns
                WAIT FOR 3600 ns;
                Go <= '1';
                Wr <= '1';
                A_in <= "110";
                -- -------------------------------------
                -- -------------  Current Time:  19385ns
                WAIT FOR 200 ns;
                Go <= '0';
                Wr <= '0';
                A_in <= "000";
                -- -------------------------------------
                WAIT FOR 815 ns;

            END PROCESS;

    END testbench_arch;

