----------------------------------------------------------------------------------
-- Company: University of Connecticut
-- Engineer: Brendan Krueger
-- 
-- Create Date:    10:18:38 07/13/2007 
-- Design Name: Delayer for ADC Controller
-- Module Name:    c_delay - c_delay_arch 
-- Project Name: ADC Module
-- Target Devices: Xilinx Spartan-3A
-- Tool versions: Xilinx ISE WebPACK 9.1.03i
-- Description: Delays a signal by one clock cycle; used to regain
--		synchronization of iCS with other signals in the controller
-- Dependencies: 
--
-- Revision: 
-- Revision 0.01 - File Created
-- Additional Comments: 
--
----------------------------------------------------------------------------------
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;

---- Uncomment the following library declaration if instantiating
---- any Xilinx primitives in this code.
--library UNISIM;
--use UNISIM.VComponents.all;

entity c_delay is
    Port ( Clk : in  STD_LOGIC;
           D : in  STD_LOGIC;
           Q : out  STD_LOGIC);
end c_delay;

architecture c_delay_arch of c_delay is

	signal temp : STD_LOGIC;

begin

	delay : process (Clk)
	begin
		if (rising_edge(Clk)) then
			temp <= D;
		else
			temp <= temp;
		end if;
	end process delay;
	
	Q <= temp;

end c_delay_arch;

