----------------------------------------------------------------------------------
-- Company: University of Connecticut
-- Engineer: Brendan Krueger
-- 
-- Create Date:    11:44:36 07/13/2007 
-- Design Name: Tri-State Buffer for ADC Emulator
-- Module Name:    e_tri - e_tri_arch 
-- Project Name: ADC Module
-- Target Devices: none; for testing and simulation only
-- Tool versions: Xilinx ISE WebPACK 9.1.03i
-- Description: One-channel tri-state buffer with active-low enable
--
-- Dependencies: 
--
-- Revision: 
-- Revision 0.01 - File Created
-- Additional Comments: 
--
----------------------------------------------------------------------------------
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;

---- Uncomment the following library declaration if instantiating
---- any Xilinx primitives in this code.
--library UNISIM;
--use UNISIM.VComponents.all;

entity e_tri is
    Port ( iEn : in  STD_LOGIC;
           D : in  STD_LOGIC;
           Q : out  STD_LOGIC);
end e_tri;

architecture e_tri_arch of e_tri is

begin

	tri: process (iEn, D)
	begin
		if (iEn = '0') then
			Q <= D;
		else
			Q <= 'Z';
		end if;
	end process;

end e_tri_arch;

